#/usr/bin/env python
import karamba
import sys
import os
import string
import commands

global counter, buttons, first, last, debug, error

browser = "konqueror"
counter = 1
prev = 0
c1 = 255
c2 = 255
c3 = 255
debug = 0
error = 0

# Autodetect the resolution, thanks to Adam Geitgey!
havexwi = os.system("which xwininfo 2>&1 > /dev/null")
if (havexwi == 0):
    pass
else:
    if debug == 1:
	print "\nCan't find xwininfo in your path."

fp = os.popen("xwininfo -root -stats")
output = fp.read()
output = output.splitlines()
i = 0
for x in output:
    param = x.split()
    if (len(param) > 1):
        if param[0].find("Width:") != -1:
	    if debug == 1:
        	print param[1]
            resX = int(param[1])
        if param[0].find("Height:") != -1:
	    if debug == 1:
        	print param[1]
            resY = int(param[1])

def deleteNews(widget):
	global lines, error_msg, error
	karamba.deleteImage(widget, news_logo)
	x = 0
	while x < (lines/2):
	    if len(news_arr) >= 2:
		karamba.deleteText(widget, news_show[x])
	    else:
		karamba.deleteText(widget, error_msg)
		error = 0
	    x += 1
	karamba.redrawWidget(widget)
	pass

def showNews(widget, directory):
	global news_arr, news_show, news_link, news_logo, active, show, error, error_msg, lines, first_news, last_news, sty
	if error == 1:
	    karamba.deleteText(widget, error_msg)
	    error = 0
	    karamba.redrawWidget(widget)
	news_show = []
	news_link = []
	if debug == 1:
	    print "Showing News for: " + directory
	news_arr = string.split(commands.getoutput("cat " + path_news + "/" + directory + "/newstemp"), "\n")
	if debug == 1:
	    print "Length of news_arr: " + str(len(news_arr))
	if len(news_arr) >= 2:
	    show = karamba.createText(widget, 230, 200, 150, 20, "Loading news")
	    news_logo = karamba.createImage(widget, 82, 42, path_news + "/" + directory + "/logo.png")
	    karamba.redrawWidget(widget)
	    x = 0
	    q = 0
	    gap = 1
	    stx = 85
	    sty = 127
	    sth = 20
	    if len(news_arr) >= 26: 
		lines = 26
	    else: 
		lines = len(news_arr)
	    while x < lines:
		if ((len(news_arr[x])*10) > 335):
		    stw = 335
		else:
		    stw = (len(news_arr[x])*10)+10
		news_show.append(karamba.createText(widget, stx, sty, stw, sth, news_arr[x]))
		news_link.insert(news_show[q], (stx, sty, stw, sth, news_arr[x+1]))
		karamba.changeTextColor(widget, news_show[q], c1,c2,c3)
		sty += (sth+gap)
		q += 1
		x += 2
	    karamba.deleteText(widget, show)
	    karamba.redrawWidget(widget)
	    active = directory
	    first_news = 0
	    last_news = len(news_show)-1
	    if debug == 1:
		print "Waiting for action..."
	else:
	    error_msg = karamba.createText(widget, 200, 150, 230, 45, "No data in news file!\nRELOAD in some time.")
	    karamba.redrawWidget(widget)
	    error = 1
	    active = directory
	    if debug == 1:
		print "Active: " + active
	pass

def movePanel(widget, act):
    w_pos = karamba.getWidgetPosition(widget)
    i = w_pos[0]
    if act == "hide":
	while i <= (resX-27):
	    karamba.moveWidget(widget, i, w_pos[1])
	    i += 1
    elif act == "show":
	while i >= (resX-465):
	    karamba.moveWidget(widget, i, w_pos[1])
	    i -= 1
    pass

def moveNews(widget, arrow):
    global news_arr, first_news, last_news, news_show, news_link, sty, lines
    tmp_lines = len(news_arr)
    if arrow == "up":
	if debug == 1:
	    print "First news: " + str(first_news)
	    print "Last news: " + str(last_news)
	    print "Lines: " + str(lines)
	    print "Num of lines: " + str(len(news_arr))
	if tmp_lines > 26 and first_news > 0:
	    karamba.deleteText(widget, news_show[12])
	    news_show.remove(news_show[12])
	    news_link.remove(news_link[12])
    	    stx = 85
	    sth = 20
	    if ((len(news_arr[((first_news-1)*2)])*10) > 335):
		stw = 335
	    else:
		stw = (len(news_arr[((first_news-1)*2)])*10)+10
	    news_show.insert(0, (karamba.createText(widget, stx, (sty+1), stw, sth, news_arr[((first_news-1)*2)])))
	    news_link.insert(0, (stx, (sty+1), stw, sth, news_arr[(((first_news-1)*2)+1)]))
	    x = 0
	    temp_y = 127
	    while x < (lines/2):
		karamba.moveText(widget, news_show[x], stx, temp_y)
		news_link[x] = (stx, temp_y, stw, sth, news_link[x][4])
		temp_y += 21
		x += 1
	    karamba.changeTextColor(widget, news_show[0], c1,c2,c3)
	    if debug == 1:
		print news_show[0]
	    karamba.redrawWidget(widget)
	    first_news -= 1
	    last_news -= 1
	pass    
    elif arrow == "down":
	if debug == 1:
	    print "First news: " + str(first_news)
	    print "Last news: " + str(last_news)
	    print "Lines: " + str(lines)
	    print "Num of lines: " + str(len(news_arr))
	if tmp_lines > 26 and ((tmp_lines/2)-1) > last_news:
	    karamba.deleteText(widget, news_show[0])
	    news_show.remove(news_show[0])
	    news_link.remove(news_link[0])
    	    stx = 85
	    sth = 20
	    if ((len(news_arr[((last_news+1)*2)])*10) > 335):
		stw = 335
	    else:
		stw = (len(news_arr[((last_news+1)*2)])*10)+10
	    news_show.insert(12, (karamba.createText(widget, stx, (sty+1), stw, sth, news_arr[((last_news+1)*2)])))
	    news_link.insert(12, (stx, (sty+1), stw, sth, news_arr[(((last_news+1)*2)+1)]))
	    x = 0
	    temp_y = 127
	    while x <= 12:
		karamba.moveText(widget, news_show[x], stx, temp_y)
		news_link[x] = (stx, temp_y, stw, sth, news_link[x][4])
		temp_y += 21
		x += 1
	    karamba.changeTextColor(widget, news_show[12], c1,c2,c3)
	    if debug == 1:
		print news_show[(lines/2)-1]
	    karamba.redrawWidget(widget)
	    first_news += 1
	    last_news += 1
	pass
    else:
	pass
    
def moveButtons(widget, arrow):
	global first, last, but_arr
	if (arrow == "up") and (last < len(dir_list)-1):
	    if debug == 1:
		print "Size of butt_arr: " + str(len(but_arr))
		print "First button is: " + but_arr[0][5]
		print "Last button is: " + but_arr[7][5]
		print "First = " + str(first)
		print "Last = " + str(last)
	    karamba.deleteImage(widget, but_arr[0][0])
	    karamba.deleteImage(widget, but_arr[0][6])
	    but_arr.remove(but_arr[0])
	    img_tmp = karamba.createImage(widget, 30, (but_arr[6][2]+46), path_news + "/" + dir_list[last+1] + "/minilogo.png")
	    img_zoom_tmp = karamba.createImage(widget, 25, (but_arr[6][2]+41), path_news + "/" + dir_list[last+1] + "/minilogo10.png")
	    karamba.hideImage(widget, img_zoom_tmp)
	    but_arr.insert(7, (img_tmp, but_arr[6][1], (but_arr[6][2]+46), but_arr[6][3], but_arr[6][4], dir_list[last+1], img_zoom_tmp))
	    q = 0
	    while q < (buttons):
		karamba.moveImage(widget, but_arr[q][0], but_arr[q][1], (but_arr[q][2]-46))
		karamba.moveImage(widget, but_arr[q][6], but_arr[q][1]-5, (but_arr[q][2]-51))
		temp_y = (but_arr[q][2]-46)
		but_arr[q] = (but_arr[q][0], but_arr[q][1], temp_y, but_arr[q][3], but_arr[q][4], but_arr[q][5], but_arr[q][6])
		if debug == 1:
		    print but_arr[q]
		q += 1
	    first += 1
	    last += 1
	    if debug == 1:
		print "Moved UP"
	elif (arrow == "down") and (first > 0):
	    if debug == 1:
		print "Last button is: " + but_arr[7][5]
		print "First = " + str(first)
		print "Last = " + str(last)	    
	    first -= 1
	    last -= 1
	    karamba.deleteImage(widget, but_arr[7][0])
	    karamba.deleteImage(widget, but_arr[7][6])
	    but_arr.remove(but_arr[7])
	    img_tmp = karamba.createImage(widget, 30, (but_arr[0][2]-46), path_news + "/" + dir_list[first] + "/minilogo.png")
	    img_zoom_tmp = karamba.createImage(widget, 25, (but_arr[6][2]-51), path_news + "/" + dir_list[first] + "/minilogo10.png")
	    karamba.hideImage(widget, img_zoom_tmp)
	    but_arr.insert(0, (img_tmp, but_arr[0][1], (but_arr[0][2]-46), but_arr[0][3], but_arr[0][4], dir_list[first], img_zoom_tmp))
	    q = 0
	    while q < (buttons):
		karamba.moveImage(widget, but_arr[q][0], but_arr[q][1], (but_arr[q][2]+46))
		karamba.moveImage(widget, but_arr[q][6], but_arr[q][1]-5, (but_arr[q][2]+41))
		temp_y = (but_arr[q][2]+46)
		but_arr[q] = (but_arr[q][0], but_arr[q][1], temp_y, but_arr[q][3], but_arr[q][4], but_arr[q][5], but_arr[q][6])
		if debug == 1:
		    print but_arr[q]
		q += 1
	    if debug == 1:
		print "Moved DOWN"
	elif last >= len(dir_list):
	    if debug == 1:
		print "ERROR: The last plugin " + str(last) + " is shown: " + but_arr[last][5]
		print "ERROR: The first plugin " + str(first) + " is shown: " + but_arr[first][5]
		print "First = " + str(first)
	        print "Last = " + str(last)
	    else:
		pass
	elif first <= 0:
	    if debug == 1:
		print "ERROR: The last plugin " + str(last) + " is shown: " + but_arr[last][5]
		print "ERROR: The first plugin " + str(first) + " is shown: " + but_arr[first][5]
		print "First = " + str(first)
		print "Last = " + str(last)
	    else:
		pass
	else:
	    print arrow
	karamba.redrawWidget(widget)
	pass

def showButtons(widget, gap):
	global img_x, img_y, img_w, img_h, buttons, img_zoom
	img_zoom = []
	q = gap
	y = 31
	x = 30
	if (len(dir_list) >= 8):
	    buttons = 8
	else:
	    buttons = len(dir_list)
	img_x = []
	img_y = []
	img_w = []
	img_h = []
	while q < buttons:
	    img.append(karamba.createImage(widget, x, y, path_news + "/" + dir_list[q] + "/minilogo.png"))
	    img_zoom.append(karamba.createImage(widget, x-5, y-5, path_news + "/" + dir_list[q] + "/minilogo10.png"))
	    karamba.hideImage(widget, img_zoom[q])
	    img_x.append(x)
	    img_y.append(y)
	    img_w.append(karamba.getImageWidth(widget, img[q]))
	    img_h.append(karamba.getImageHeight(widget, img[q]))
	    y += img_h[q]
	    q += 1
	karamba.addImageTooltip(widget, karamba.getThemeImage(widget, "up_panel"), "Move Up")
	karamba.addImageTooltip(widget, karamba.getThemeImage(widget, "down_panel"), "Move Down")
	karamba.addImageTooltip(widget, karamba.getThemeImage(widget, "up_news"), "Slide Up")
	karamba.addImageTooltip(widget, karamba.getThemeImage(widget, "reload"), "Update")
	karamba.addImageTooltip(widget, karamba.getThemeImage(widget, "down_news"), "Slide Down")
	pass

def downloadNews(widget, directory, i):
	os.system(path_news + "/" + directory + "/getNews &")
	tip_arr = string.split(directory, "_")
	dir_name = karamba.createText(widget, 300, 370, 100, 20, tip_arr[1])
	karamba.changeTextColor(widget, dir_name, 255, 255, 255)
	karamba.changeTextSize(widget, dir_name, 9)
	karamba.redrawWidget(widget)
	if debug == 1:
	    print "Updating News for: " + directory
	karamba.deleteText(widget, dir_name)
        pass

def initWidget(widget):
	global path_main, path_news, path_pics
	global dir_list, dir_count
	global img, tip
	global active
	global first, last
	global news_link
	global zoomed
	zoomed = 0
	img = []
	tip = []
	news_link = ""
        path_main = karamba.getThemePath(widget)
        path_news = path_main + "/news"
        path_pics = path_main + "/pics"
	dir_list = string.split(commands.getoutput("ls " + path_news), "\n")
	first = 0
	last = 7
	buttons = 8
	dir_count = len(dir_list)
	showButtons(widget, 0)
	karamba.createClickArea(widget, 425, 345, 22, 22, "")
	ver = string.split(commands.getoutput("cat " + path_main + "/CHANGELOG | head -n +1"), "(")
	karamba.createText(widget, 370, 30, 75, 20, ver[0])
	buttonTable(widget)

def updateData(widget, coun):
	if (coun == 1):
	    updating = karamba.createText(widget, 300, 335, 150, 35, "Updating")
	    karamba.changeTextSize(widget, updating, 23)
	    karamba.changeTextShadow(widget, updating, 3)
	    karamba.changeTextColor(widget, updating, 0, 255, 255)
	    karamba.redrawWidget(widget)
	    if debug == 1:
		print "Started Download"
	    i = 0
	    for i in xrange(len(dir_list)):
		downloadNews(widget, dir_list[i], i)
		i += 1
	    karamba.hideText(widget, updating)
	    karamba.redrawWidget(widget)
	    if debug == 1:
		print "Finished Download"
	    pass
	elif (coun == 2):
	    showNews(widget, dir_list[0])
	    pass
	else:
	    pass

def widgetUpdated(widget):
	global counter
        updateData(widget, counter)
	counter += 1
	pass

def widgetClicked(widget, x, y, button):
	global first, active, error
	if button == 1:
	    if (0 <= x <= 27) and (160 <= y <= 272): # Handle
		w_pos = karamba.getWidgetPosition(widget)
		if (w_pos[0] < (resX-27)):
		    if debug == 1:
			print "Position is: LEFT " + str(w_pos)
		    movePanel(widget, "hide")
		elif (w_pos[0] == (resX-27)):
		    if debug == 1:
			print "Position is: RIGHT " + str(w_pos)
		    movePanel(widget, "show")
		pass
	    size = 7
	    v = 0
	    q = 0
	    changed = ""
	    while v <= size:
		if (but_arr[v][1] <= x <= (but_arr[v][3]+but_arr[v][1])) and (but_arr[v][2] <= y <= (but_arr[v][2]+but_arr[v][4])): # buttons
		    show = karamba.createText(widget, 230, 200, 150, 20, "Loading news")
		    deleteNews(widget)
		    karamba.deleteText(widget, show)
		    showNews(widget, but_arr[v][5])
		    active = but_arr[v][5]
		v += 1
	    for q in range(len(news_link)):
		link_x = news_link[q][0]
		link_y = news_link[q][1]
		link_w = news_link[q][2]
		link_h = news_link[q][3]
		link_u = news_link[q][4]
		if (link_x <= x <= (link_x+link_w)) and (link_y <= y <= (link_y+link_h)) and (button ==1):
		    os.system(browser + " '%s' &" %(link_u))
		    changed = karamba.changeTextColor(widget, news_show[q], 255,0,0)
		    karamba.redrawWidget(widget)
		    if changed != "":
			changed = ""
		        karamba.changeTextColor(widget, news_show[q], c1,c2,c3)
			karamba.redrawWidget(widget)
		q += 1
	    if (421 <= x <= 451) and (341 <= y <= 371): # Reload button
		show = karamba.createText(widget, 230, 200, 150, 20, "Loading news")
		if debug == 1:
		    print "--- RELOAD ---"
		downloadNews(widget, active, 1)
		if error == 0:
		    deleteNews(widget)
		showNews(widget, active)
		karamba.deleteText(widget, show)
	    if (29 <= x <= 70) and (0 <= y <= 25): # Up arrow on panel
		moveButtons(widget, "down")
	    if (29 <= x <= 70) and (403 <= y <= 428): # Down arrow on panel
		moveButtons(widget, "up")
	    if (425 <= x <= 447) and (318 <= y <= 340): # Up_news
		moveNews(widget, "up")
	    if (425 <= x <= 447) and (372 <= y <= 394): # Down_news
		moveNews(widget, "down")
	else:
	    if debug == 1:
		print "Button no: " + str(button)
	    pass
        pass

def widgetMouseMoved(widget, x, y, button):
	global prev
	global first
	global last, rel, up_panel, down_panel, news_link, zoom, arrows, error
	v = 0
	size = 7
	if news_link != "": # Something is wrong here :(
	    if error == 0: pos = MouseOver(widget, x, y)
	    else: pos = 0
	if (421 <= x <= 451) and (341 <= y <= 371): # Reload
	    zoom = 1
	    arrow(widget, 421, 341, "reload", "reloadlight")
	else:
	    zoom = 0
	    arrow(widget, 421, 341, "reload", "reloadlight")
	if (29 <= x <= 70) and (0 <= y <= 25): # Up_panel
	    zoom = 1
	    arrow(widget, 29, 0, "up_panel", "uparrow-panel_light")
	else:
	    zoom = 0
	    arrow(widget, 29, 0, "up_panel", "uparrow-panel_light")
	if (29 <= x <= 70) and (403 <= y <= 428): # Down_panel
	    zoom = 1
	    arrow(widget, 29, 403, "down_panel", "downarrow-panel_light")
	else:
	    zoom = 0
	    arrow(widget, 29, 403, "down_panel", "downarrow-panel_light")
	if (425 <= x <= 447) and (318 <= y <= 340): # Up_news
	    zoom = 1
	    arrow(widget, 425, 318, "up_news", "uparrow-inside_light")
	else:
	    zoom = 0
	    arrow(widget, 425, 318, "up_news", "uparrow-inside_light")
	if (425 <= x <= 447) and (372 <= y <= 394): # Down_news
	    zoom = 1
	    arrow(widget, 425, 372, "down_news", "downarrow-inside_light")
	else:
	    zoom = 0
	    arrow(widget, 425, 372, "down_news", "downarrow-inside_light")

	if (pos >= 0) and (prev != pos):
	    karamba.changeTextColor(widget, news_show[prev], c1,c2,c3)
	    karamba.changeTextShadow(widget, news_show[prev], 0)
	    prev = pos	    
	    karamba.changeTextColor(widget, news_show[pos], 255,255,100)
	    karamba.changeTextShadow(widget, news_show[pos], 2)
	    karamba.redrawWidget(widget)
	elif pos < 0:
	    karamba.changeTextColor(widget, news_show[prev], c1,c2,c3)
	    karamba.changeTextShadow(widget, news_show[prev], 0)
	    karamba.redrawWidget(widget)
	while v <= size:
	    if (but_arr[v][1] <= x <= (but_arr[v][3]+but_arr[v][1])) and (but_arr[v][2] <= y <= (but_arr[v][4]+but_arr[v][2])):
		zoom = 1
		butt(widget, v)
	    else:
		zoom = 0
		butt(widget, v)
	    if debug == 1:
	        print "RESIZE: " + but_arr[v][5]
	    v += 1
	pass

def butt(widget, img_org): # Buttons effects
	global zoom, but_arr
        if debug == 1:
	    print "Button zoom: " + str(zoom)
	if zoom == 1:
	    karamba.hideImage(widget, but_arr[img_org][0])
	    karamba.showImage(widget, but_arr[img_org][6])
	else:
	    karamba.hideImage(widget, but_arr[img_org][6])
	    karamba.showImage(widget, but_arr[img_org][0])
	pass

def arrow(widget, x, y, img_org, img_new): # Arrows and reload "light" effects
	global zoom, arrows
        if debug == 1:
	    print "Arrow zoom: " + str(zoom)
	if zoom == 1:
	    karamba.hideImage(widget, karamba.getThemeImage(widget, img_org))
	    karamba.showImage(widget, arrows[img_new])
	else:
	    karamba.hideImage(widget, arrows[img_new])
	    karamba.showImage(widget, karamba.getThemeImage(widget, img_org))
	pass

def MouseOver(widget, x, y): # Mouse over the news
	global result, news_link
	result = -1
	q = 0
        for q in range(len(news_link)):
	    link_x = news_link[q][0]
	    link_y = news_link[q][1]
	    link_w = news_link[q][2]+link_x
	    link_h = news_link[q][3]+link_y
	    if (x < link_x) or (x > link_w):
		pass
	    elif (y < link_y) or (y > link_h):
		pass
	    else:
		result = q
	    q += 1
	return result

def buttonTable(widget): # Main array with buttons parameters
    global but_arr, arrows, img_zoom
    arrows = {}
    licz = 0
    y = 31
    but_arr = []
    while licz < buttons:
	but_arr.insert(licz,(img[licz], 30, y, 41, 46, dir_list[licz], img_zoom[licz]))
	y += 46
	licz += 1
    if debug == 1:
	print "Loaded Button Table"
	print "We have " + str(buttons) + " buttons"
    arrows['reloadlight'] = karamba.createImage(widget, 421, 341, path_pics + "/reloadlight.png")
    arrows['uparrow-panel_light'] = karamba.createImage(widget, 29, 0, path_pics + "/uparrow-panel_light.png")
    arrows['downarrow-panel_light'] = karamba.createImage(widget, 29, 403, path_pics + "/downarrow-panel_light.png")
    arrows['uparrow-inside_light'] = karamba.createImage(widget, 425, 318, path_pics + "/uparrow-inside_light.png")
    arrows['downarrow-inside_light'] = karamba.createImage(widget, 425, 372, path_pics + "/downarrow-inside_light.png")
    for k, v in arrows.items():
	karamba.hideImage(widget, v)
	if debug == 1:
	    print "Arrows key: " + k
    karamba.redrawWidget(widget)
    pass

print "Theme loaded."
